<template>
  <span>
    <gl-button id="scim-filter-help" variant="link" icon="question-o" aria-label="Help" />
    <gl-popover target="scim-filter-help">
      Example filters:

      <ul class="gl-pl-5">
        <li v-for="(example, description) in $options.exampleQueries" :key="example">
          <gl-button variant="link" class="gl-text-wrap-wrap" @click="$emit('query', example)">{{
            description
          }}</gl-button>
        </li>
      </ul>

      Useful properties of findings to filter on:

      <ul class="gl-pl-5">
        <li v-for="property in $options.usefulFindingProperties" :key="property">
          <code>{{ property }}</code>
        </li>
      </ul>
    </gl-popover>
  </span>
</template>

<script>
import GlButton from '@gitlab/ui/src/components/base/button/button.vue';
import GlPopover from '@gitlab/ui/src/components/base/popover/popover.vue';

export default {
  name: 'ScimFilterHelp',
  components: {
    GlButton,
    GlPopover,
  },
  exampleQueries: {
    'Buttons only': 'extra.metadata.componentLabel eq "component:button"',
    'Pajamas Non-Compliant': 'extra.metadata.pajamasCompliant eq false',
    'Warnings and errors in vue_shared': 'extra.severity ne "INFO" and path co "vue_shared"',
    'Warnings with "render" in code': 'extra[lines co "render" and severity eq "WARNING"]',
    'Warnings in Vue or JS files':
      'extra.severity eq "WARNING" and (path ew ".vue" or path ew ".js")',
    'Non-compliant Foundations':
      'extra[metadata.pajamasCompliant eq false and group eq "group::foundations"]',
    'Findings with migration guides': 'extra[metadata.epic pr and severity ne "INFO"]',
    'Findings without migration guides': 'extra[not metadata.epic pr and severity ne "INFO"]',
  },
  usefulFindingProperties: [
    'check_id',
    'extra.group',
    'extra.lines',
    'extra.message',
    'extra.metadata.componentLabel',
    'extra.metadata.pajamasCompliant',
    'extra.metadata.epic',
    'extra.severity',
    'path',
  ],
};
</script>
